/*
 * arch/arm/include/asm/hardware/pmc.h
 *
 * MPCore Performance Monitor Register Access
 *
 * Copyright 2005,2006,2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __ASM_HARDWARE_PMC_H__
#define __ASM_HARDWARE_PMC_H__

#define PMC_PMNC 0
# define PMNC_E		0x00000001
# define PMNC_PMNX_CLR	0x00000002
# define PMNC_CCNT_CLR	0x00000004
# define __PMC_RESTART	0x07
# define PMNC_IEN_PMN0	0x00000010
# define PMNC_IEN_PMN1	0x00000020
# define PMNC_IEN_CCNT	0x00000040
# define PMNC_OVF_PMN0	0x00000100
# define PMNC_OVF_PMN1	0x00000200
# define PMNC_OVF_CCNT	0x00000400
# define PMNC_OVF_MASK	0x00000700
# define PMNC_PMN0_SHIFT 20
# define PMNC_PMN1_SHIFT 12
#define PMC_CCNT 1
#define PMC_PMN0 2
#define PMC_PMN1 3

#define rdpmc(id,val) \
	asm volatile ("mrc p15,0,%0,c15,c12," __stringify(id) \
		      :"=r"(val)::"cc");
#define wrpmc(id,val) \
	asm volatile ("mcr p15,0,%0,c15,c12," __stringify(id) \
                      ::"r"(val):"cc");

#ifdef CONFIG_OPROFILE
static inline void pmc_restart(unsigned char ev1, unsigned char ev2)
{
}
#else
static inline void pmc_restart(unsigned char ev1, unsigned char ev2)
{
	register unsigned int pmnc;

	pmnc = (ev1 << 20) | (ev2 << 12) | __PMC_RESTART;
	asm volatile("mcr p15,0,%0,c15,c12,0" ::"r"(pmnc):"cc");
}
#endif /* CONFIG_OPROFILE */
#endif /* __ASM_HARDWARE_PMC_H__ */
