/*
 * include/asm-arm/mach/xmodem.h
 *
 * xmodem device header for warmboot
 *
 * Copyright 2005,2006 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *
 */

#ifndef __XMODEM_H__
#define __XMODEM_H__

#if defined(CONFIG_WBI_DEV_XMODEM)
#include <asm/mach/warmboot.h>

struct xmodem_device {
	char *name;
	struct wb_device *wb_device;
	void (*open)(struct xmodem_device *);
	int (*inb)(struct xmodem_device *, unsigned char *);
	int (*outb)(struct xmodem_device *, unsigned char);
	void (*close)(struct xmodem_device *);
	void *data;
};

int xmodem_register_device(struct xmodem_device *);
int xmodem_unregister_device(struct xmodem_device *);
#else
#define xmodem_register_device(dev) do{}while(0);
#define xmodem_unregister_device(dev) do{}while(0);
#endif

#endif

