/*
 * arch/arm/mach-cxd4115/dma.c
 *
 *
 * Copyright 2007,2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#include <linux/module.h>
#include <asm/delay.h>
#include <mach/dma.h>

int dma_stop(unsigned int ch)
{
	int retry = 3;
	unsigned long cfg;

	while (unlikely((cfg = readl(DMACCCONFIGURATION_(ch))) & DMACCCONFIG_ENABLE) && retry > 0) {
		printk("DMAC Halt(retry = %d) cfg = 0x%08lx\n", retry, cfg);
		writel(DMACCCONFIG_HALT, DMACCCONFIGURATION_(ch));
		writel(0, DMACCLLI_(ch));
		udelay(10);
		writel(0, DMACCCONFIGURATION_(ch));
		retry--;
	}

	if (unlikely(!retry))
		return -EIO;

	return 0;
}

EXPORT_SYMBOL(dma_stop);
