/*
 * include/asm-arm/arch-cxd4115/bam.h
 *
 * BAM definitions
 *
 * Copyright 2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __ARCH_CXD4115_REGS_BAM_H
#define __ARCH_CXD4115_REGS_BAM_H

#define BAM_LOAD_SET		0x014
#ifdef CONFIG_ARCH_CXD4120
# define BAM_MODE_NONE		 0x00000000
# define BAM_MODE_COUNT		 0x10000000
# define BAM_MODE_CHECK		 0x20000000
# define BAM_CTRL_CPU		 0x00000000
# define BAM_CTRL_SYNC0		 0x01000000
# define BAM_CTRL_SYNC1		 0x02000000
# define BAM_CTRL_TIMER	 	 0x03000000
#define BAM_DMC_SELECT		0x02c
#define BAM_MON_START		0x030
# define BAM_START		 0x01
#else /* CONFIG_ARCH_CXD4120 */
# define BAM_MODE_NONE		 0x00
# define BAM_MODE_COUNT		 0x10
# define BAM_MODE_CHECK		 0x20
# define BAM_CTRL_CPU		 0x00
# define BAM_CTRL_SYNC0		 0x01
# define BAM_CTRL_SYNC1		 0x02
# define BAM_CTRL_TIMER	 	 0x03
# define BAM_START		 0x04
#endif /* CONFIG_ARCH_CXD4120 */
#define BAM_AXI_MON1_IP1	0x100
#define BAM_AXI_MON1_IP2	0x104
#define BAM_MON1_BURST4_COUNT	0x108
#define BAM_MON1_BURST8_COUNT	0x10c
#define BAM_MON1_BURST12_COUNT	0x110
#define BAM_MON1_BURST16_COUNT	0x114
#define BAM_MON1_BURST_COUNT	0x118
#define BAM_DDR_WDQ_IP1		0x124
#define BAM_DDR_RDQ_IP1		0x128

#define BAM_AXI_MON2_IP1	0x200
#define BAM_AXI_MON2_IP2	0x204
#define BAM_MON2_BURST_COUNT	0x218

#ifdef CONFIG_ARCH_CXD4120
# define BAM_AXI_MON_IP1_ALL	 0xffffffff
#else
# define BAM_AXI_MON_IP1_ALL	 0x0fffffff
#endif /* CONFIG_ARCH_CXD4120 */
# define BAM_AXI_MON_IP2_ALL	 0xffffffff

#define BAM_COUNT_MAX		0x000fffff

#ifdef CONFIG_ARCH_CXD4115
/* IP0..31 */
# define BAM_CPU_R0	21
//# define BAM_CPU_R0	17   /* CXD9938 */
#endif /* CONFIG_ARCH_CXD4115 */

#endif
