/*
 * arch/arm/mach-cxd4132/include/mach/udif/devno.h
 *
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __UDIF_DEVNO_H__
#define __UDIF_DEVNO_H__

#include <linux/udif/devnode.h>

typedef enum {
	UDIF_NODE_GPIO = 0,
	UDIF_NODE_USB_EVENT,
	UDIF_NODE_USB_GCORE,
	UDIF_NODE_USB_OCORE,
	UDIF_NODE_USB_CORE,
	UDIF_NODE_USB_SCSI,
	UDIF_NODE_UIO,
	UDIF_NODE_NUM,
} UDIF_NODE_ID;

#if defined UDIF_DEVNODE_HAS_INSTANCE || !defined __KERNEL__
UDIF_DEVNODE __udif_devnodes[] = {
	[UDIF_NODE_GPIO] =	{"gpio", UDIF_TYPE_CDEV, 240, 0, 1},
	[UDIF_NODE_USB_EVENT] =	{"usb/event",		UDIF_TYPE_CDEV, 242, 0, 1},
	[UDIF_NODE_USB_GCORE] =	{"usb/gadgetcore",	UDIF_TYPE_CDEV, 242, 1, 1},
	[UDIF_NODE_USB_OCORE] =	{"usb/otgcore",		UDIF_TYPE_CDEV, 242, 2, 1},
	[UDIF_NODE_USB_CORE] =	{"usb/usbcore",		UDIF_TYPE_CDEV, 242, 3, 1},
	[UDIF_NODE_USB_SCSI] =	{"usb/scsi",		UDIF_TYPE_CDEV, 242, 4, 1},
	[UDIF_NODE_UIO] =	{"uio0", UDIF_TYPE_CDEV, 254, 0, 1},
};

#ifdef __KERNEL__
 #include <linux/module.h>
 EXPORT_SYMBOL(__udif_devnodes);
#endif

#else /* UDIF_DEVNODE_HAS_INSTANCE || !_KERNEL__ */
 extern UDIF_DEVNODE __udif_devnodes[UDIF_NODE_NUM];
#endif /* UDIF_DEVNODE_HAS_INSTANCE || !_KERNEL__ */

#define udif_device_node(id) (((id) < UDIF_NODE_NUM) ? &__udif_devnodes[id] : NULL)

#endif /* __UDIF_DEVNO_H__ */
