/*
 * arch/arm/mach-cxd4132/pl310.S
 *
 * PL310 helper for CXD4132
 *
 * Copyright 2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <linux/linkage.h>
#include <asm/assembler.h>
#include <mach/time.h>
#include <mach/hardware.h>

	.text
#ifdef CONFIG_CACHE_PL310_INIT
ENTRY(cxd4132_pl310_init)
	@ r0-r3 corrupted
	@ preserve r4
	ldr	r0, =CXD4132_PL310_BASE
	adr	r1, pl310_param
	b	pl310_init		@ r2,r3 corrupted

pl310_param:
	.long	0xcfffebff		@ AUX mask
#ifdef CONFIG_CACHE_PL310_EXCLUSIVE
	.long	0x00001000		@ AUX val
					@   Exclusive cache
#else
	.long	0x00000000		@ AUX val
					@   Inclusive cache
#endif
	.long	0x000			@ TagRAM Latency(1/1/1)
	.long	0x000			@ DataRAM Latency(1/1/1)
#endif /* CONFIG_CACHE_PL310_INIT */

ENTRY(cxd4132_pl310_shutdown)
	@ r0-r2 corrupted
	ldr	r0, =CXD4132_PL310_BASE
	b	pl310_shutdown		@ r1,r2 corrupted


ENTRY(cxd4132_pl310_setup)
	@ r0-r3 corrupted
#ifdef CONFIG_CACHE_PL310_INIT
	b	cxd4132_pl310_init	@ r0-r3 corrupted
#else /* CONFIG_CACHE_PL310_INIT */
	@ takeover PL310 setting
	mov	r3, lr			@ save lr
	ldr	r0, =CXD4132_PL310_BASE
	bl	pl310_read_config	@ r0,r1 corrupted
	ands	r0, #2			@ Exclusive mode ?
	moveq	pc, r3			@ return
	@ set exclusive_cache flag
	adr	r0, 1f
	ldmia	r0, {r1, r2}
	sub	r0, r0, r1
	add	r2, r2, r0
	mov	r0, #1
	str	r0, [r2]
	mov	pc, r3			@ return
#endif /* CONFIG_CACHE_PL310_INIT */
1:
	.long	.
	.long	exclusive_cache
	.ltorg

	.data
	.type	exclusive_cache, #object
ENTRY(exclusive_cache)
#ifdef CONFIG_CACHE_PL310_EXCLUSIVE
	.long	1
#else
	.long	0
#endif
