/*
 * arch/arm/mach-cxd4132/sdc.h
 *
 * SDC driver header
 *
 * Copyright 2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef __ARCH_CXD4132_SDC_H__
#define __ARCH_CXD4132_SDC_H__

#include <linux/udif/device.h>
#include <linux/udif/spinlock.h>
#include <linux/udif/macros.h>

#define SDC_MAX_RANK	2

#include "sdc-zqcal.h"

struct sdc_dev_t {
	UDIF_U32	magic;
	const UDIF_DEVICE	*udev;

	UDIF_SPINLOCK	sdc_lock;
	UDIF_VA		vaddr;
	UDIF_INT	is_2rank;
	UDIF_INT	is_ddr2;
	UDIF_U32	errors;
	/* ZQcal stuff */
	struct zqcal_ctl zqcal;
};
/* magic */
#define SDC_DEV_MAGIC 0x00434453
#define SDC_DEV_FREE  0
/* errors */
#define SDC_ERR_NONE	0
#define SDC_ERR_TIMEOUT	0x00000001

extern void sdc_ddr2_mrw(struct sdc_dev_t *dev, UDIF_U32 cmd,
			 UDIF_U32 ma, UDIF_U32 op, UDIF_U32 tMRW);

#endif /* __ARCH_CXD4132_SDC_H__ */
