/*
 * noncache-common.h
 *
 * Physical address to NonCacheable address converter
 *
 * Copyright 2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef __PLAT_CXD41XX_INCLUDE_MACH_NONCACHE_H
#define __PLAT_CXD41XX_INCLUDE_MACH_NONCACHE_H
/*
 * PA2NC_ERR - Return value on error
 *   CAUTION: This value should be within 0x00000000..0x00000fff.
 *            0x00000000..0x000000ff is recommended.
 */
#define PA2NC_ERR	(0UL)

#define PA2NC_IN(addr, range)	(PA2NC_##range##_START <= (addr) \
				  && (addr) < PA2NC_##range##_END)

#define PA2NC_END(dev, type)	(PA2NC_##type##_##dev##_START + PA2NC_##dev##_SIZE)

/* misc macros */
#define VA_TO_NONCACHE(x)	PHYS_TO_NONCACHE(VA_TO_PHYS(x))
#define VA_TO_CACHE(x)		PHYS_TO_CACHE(VA_TO_PHYS(x))

#endif /* __PLAT_CXD41XX_INCLUDE_MACH_NONCACHE_H */
