/*
 * include/linux/decompress_driver.h
 *
 *
 * Copyright 2008,2009,2010 Sony Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
#ifndef __DECOMPRESS_DRIVER_H
#define __DECOMPRESS_DRIVER_H

#include <linux/list.h>
#include <linux/mm.h>

#define DECOMPRESS_FLAG_LZO	0x00000001
#define DECOMPRESS_FLAG_LZ77	0x00000002

struct decompress_driver {
	struct list_head list;
	u32 flag;
	int (*decompress)(void *dst, u32 dstlen, void *src, u32 srclen, void *data);
	void *data;
};

extern int decompress_driver_register(struct decompress_driver *driver);
extern void decompress_driver_unregister(struct decompress_driver *driver);
extern u32 call_decompress_driver(u32 flags, void *dst, u32 dstlen, void *src, u32 srclen);

#endif /* __DECOMPRESS_DRIVER_H */
