/*
 * Copyright 2009 Sony Corporation
 */
#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

struct _elf_info {
	char *filename;
	struct file *file;
	mm_segment_t fs;
	Elf32_Shdr sh_dynsym;
	Elf32_Shdr sh_dynstr;
	Elf32_Shdr sh_strtab;
	Elf32_Shdr sh_symtab;
	unsigned long addr_offset;
	unsigned long addr_end;
	int strip;
};

#define CALLSTACK_STR_SZ 127
struct callstack {
	unsigned long entry;
	unsigned long caller;
#define CALLER_END       (-1UL)
#define CALLER_SP        (-2UL)
#define CALLER_USER      (-3UL)

	unsigned long size;
	struct _elf_info *elf_info;
	char entry_str[CALLSTACK_STR_SZ + 1];
};

extern void em_cmd_v2p(int argc, char **argv);
extern void em_dump_regs(int argc, char **argv);
extern void em_dump_stack(int argc, char **argv);
extern void em_dump_regs_detail(int argc, char **argv);
extern struct callstack *em_get_callstack(void);
extern void em_show_syndrome(void);

extern void em_dump_write(const char *format, ...);
extern char *em_get_execname(void);

#endif
